# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rm_msgs/KalmanData.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg

class KalmanData(genpy.Message):
  _md5sum = "076b9f9dc5aab232f694a2e05a2a0a8c"
  _type = "rm_msgs/KalmanData"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """std_msgs/Header header
geometry_msgs/Pose real_detection_pose
geometry_msgs/Pose filtered_detection_pose
geometry_msgs/Twist real_detection_twist
geometry_msgs/Twist filtered_detection_twist

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z"""
  __slots__ = ['header','real_detection_pose','filtered_detection_pose','real_detection_twist','filtered_detection_twist']
  _slot_types = ['std_msgs/Header','geometry_msgs/Pose','geometry_msgs/Pose','geometry_msgs/Twist','geometry_msgs/Twist']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,real_detection_pose,filtered_detection_pose,real_detection_twist,filtered_detection_twist

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(KalmanData, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.real_detection_pose is None:
        self.real_detection_pose = geometry_msgs.msg.Pose()
      if self.filtered_detection_pose is None:
        self.filtered_detection_pose = geometry_msgs.msg.Pose()
      if self.real_detection_twist is None:
        self.real_detection_twist = geometry_msgs.msg.Twist()
      if self.filtered_detection_twist is None:
        self.filtered_detection_twist = geometry_msgs.msg.Twist()
    else:
      self.header = std_msgs.msg.Header()
      self.real_detection_pose = geometry_msgs.msg.Pose()
      self.filtered_detection_pose = geometry_msgs.msg.Pose()
      self.real_detection_twist = geometry_msgs.msg.Twist()
      self.filtered_detection_twist = geometry_msgs.msg.Twist()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_26d().pack(_x.real_detection_pose.position.x, _x.real_detection_pose.position.y, _x.real_detection_pose.position.z, _x.real_detection_pose.orientation.x, _x.real_detection_pose.orientation.y, _x.real_detection_pose.orientation.z, _x.real_detection_pose.orientation.w, _x.filtered_detection_pose.position.x, _x.filtered_detection_pose.position.y, _x.filtered_detection_pose.position.z, _x.filtered_detection_pose.orientation.x, _x.filtered_detection_pose.orientation.y, _x.filtered_detection_pose.orientation.z, _x.filtered_detection_pose.orientation.w, _x.real_detection_twist.linear.x, _x.real_detection_twist.linear.y, _x.real_detection_twist.linear.z, _x.real_detection_twist.angular.x, _x.real_detection_twist.angular.y, _x.real_detection_twist.angular.z, _x.filtered_detection_twist.linear.x, _x.filtered_detection_twist.linear.y, _x.filtered_detection_twist.linear.z, _x.filtered_detection_twist.angular.x, _x.filtered_detection_twist.angular.y, _x.filtered_detection_twist.angular.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.real_detection_pose is None:
        self.real_detection_pose = geometry_msgs.msg.Pose()
      if self.filtered_detection_pose is None:
        self.filtered_detection_pose = geometry_msgs.msg.Pose()
      if self.real_detection_twist is None:
        self.real_detection_twist = geometry_msgs.msg.Twist()
      if self.filtered_detection_twist is None:
        self.filtered_detection_twist = geometry_msgs.msg.Twist()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 208
      (_x.real_detection_pose.position.x, _x.real_detection_pose.position.y, _x.real_detection_pose.position.z, _x.real_detection_pose.orientation.x, _x.real_detection_pose.orientation.y, _x.real_detection_pose.orientation.z, _x.real_detection_pose.orientation.w, _x.filtered_detection_pose.position.x, _x.filtered_detection_pose.position.y, _x.filtered_detection_pose.position.z, _x.filtered_detection_pose.orientation.x, _x.filtered_detection_pose.orientation.y, _x.filtered_detection_pose.orientation.z, _x.filtered_detection_pose.orientation.w, _x.real_detection_twist.linear.x, _x.real_detection_twist.linear.y, _x.real_detection_twist.linear.z, _x.real_detection_twist.angular.x, _x.real_detection_twist.angular.y, _x.real_detection_twist.angular.z, _x.filtered_detection_twist.linear.x, _x.filtered_detection_twist.linear.y, _x.filtered_detection_twist.linear.z, _x.filtered_detection_twist.angular.x, _x.filtered_detection_twist.angular.y, _x.filtered_detection_twist.angular.z,) = _get_struct_26d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_26d().pack(_x.real_detection_pose.position.x, _x.real_detection_pose.position.y, _x.real_detection_pose.position.z, _x.real_detection_pose.orientation.x, _x.real_detection_pose.orientation.y, _x.real_detection_pose.orientation.z, _x.real_detection_pose.orientation.w, _x.filtered_detection_pose.position.x, _x.filtered_detection_pose.position.y, _x.filtered_detection_pose.position.z, _x.filtered_detection_pose.orientation.x, _x.filtered_detection_pose.orientation.y, _x.filtered_detection_pose.orientation.z, _x.filtered_detection_pose.orientation.w, _x.real_detection_twist.linear.x, _x.real_detection_twist.linear.y, _x.real_detection_twist.linear.z, _x.real_detection_twist.angular.x, _x.real_detection_twist.angular.y, _x.real_detection_twist.angular.z, _x.filtered_detection_twist.linear.x, _x.filtered_detection_twist.linear.y, _x.filtered_detection_twist.linear.z, _x.filtered_detection_twist.angular.x, _x.filtered_detection_twist.angular.y, _x.filtered_detection_twist.angular.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.real_detection_pose is None:
        self.real_detection_pose = geometry_msgs.msg.Pose()
      if self.filtered_detection_pose is None:
        self.filtered_detection_pose = geometry_msgs.msg.Pose()
      if self.real_detection_twist is None:
        self.real_detection_twist = geometry_msgs.msg.Twist()
      if self.filtered_detection_twist is None:
        self.filtered_detection_twist = geometry_msgs.msg.Twist()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 208
      (_x.real_detection_pose.position.x, _x.real_detection_pose.position.y, _x.real_detection_pose.position.z, _x.real_detection_pose.orientation.x, _x.real_detection_pose.orientation.y, _x.real_detection_pose.orientation.z, _x.real_detection_pose.orientation.w, _x.filtered_detection_pose.position.x, _x.filtered_detection_pose.position.y, _x.filtered_detection_pose.position.z, _x.filtered_detection_pose.orientation.x, _x.filtered_detection_pose.orientation.y, _x.filtered_detection_pose.orientation.z, _x.filtered_detection_pose.orientation.w, _x.real_detection_twist.linear.x, _x.real_detection_twist.linear.y, _x.real_detection_twist.linear.z, _x.real_detection_twist.angular.x, _x.real_detection_twist.angular.y, _x.real_detection_twist.angular.z, _x.filtered_detection_twist.linear.x, _x.filtered_detection_twist.linear.y, _x.filtered_detection_twist.linear.z, _x.filtered_detection_twist.angular.x, _x.filtered_detection_twist.angular.y, _x.filtered_detection_twist.angular.z,) = _get_struct_26d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_26d = None
def _get_struct_26d():
    global _struct_26d
    if _struct_26d is None:
        _struct_26d = struct.Struct("<26d")
    return _struct_26d
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
